{-# LANGUAGE DataKinds #-}
{-# LANGUAGE DeriveGeneric #-}
{-# LANGUAGE TypeOperators #-}
{-# LANGUAGE OverloadedStrings #-}

module HAL.Client where

import Data.Proxy
import GHC.Generics
import Servant.API
import Servant.Client hiding (Response)
import Data.Text
import Data.Map
import Data.Aeson

data Response = Response
  {
    numFound :: Integer,
    start :: Int,
    docs :: [Doc]
  } deriving (Show, Generic)

instance FromJSON Response where
  parseJSON (Object o) = Response <$>
                         ((o .: "response") >>= (.: "numFound"))
                         <*> ((o .: "response") >>= (.: "start"))
                         <*> ((o .: "response") >>= (.: "docs"))

newtype Doc = Doc (Map Text Value)
  deriving (Show, Generic)
instance FromJSON Doc

type HALAPI = Search

type Search = "search"
  -- fl determine which fields will be returned it can be a list of fields or *
  :> QueryParam "fl" Text :> Get '[JSON] Response

halAPI :: Proxy HALAPI
halAPI = Proxy

fl :: Maybe Text -> ClientM Response
fl = client halAPI
